#!/usr/bin/perl -w
#
# Zamfir version 1.1 (a script for generating a tone when someone /msgs you.
# Written by Craig Maloney <craig@ic.net>
# Based off of away.pl <frb@umr.edu> and sample_script.pl
# <eriks@chilisoft.com>
#
# I called this script zamfir because:
# a) I wanted this script to load last, after the ignore scripts.
# b) zamfir was the only musical name I could come up with that began with
#    a Z. Sure, there's Zildjian, but who wants to type that?
# c) This script can get pretty annoying after a while, and while I haven't
#    heard the original Zamfir's work, I've been told he can get pretty
#    annoying after a while as well.
#
# This script has received the bare minimum of testing (read: it works for me)
# so if you have any problems with it, please feel free to send me mail.
# <craig@ic.net>

IRC::print ":: Loading Zamfir 1.1::\n";

IRC::add_message_handler("PRIVMSG", "privmsg_handler");
IRC::add_command_handler("zamfir", "zamfir_command_handler");

$my_nick = IRC::get_info(1);

$msg_cmd='nmaker';
$msg_file='/home/craig/audio/wav/bell.wav';
$zamfir_sound = 1;
undef %nicks;
&zamfir_config_file;

sub privmsg_handler
{
	if ($zamfir_sound == 0) {
		return 0;
	} else {

		my $line = shift(@_);
		$line =~ /:(.*)!(.*@.*) .*:(.*)/;

		@list = split /!/,$line;
		if ($2=~/$my_nick/i) {
			if ($beeponce == 0) {
				system (`$msg_cmd $msg_file`);
			} else {
				if ($nicks{$list[0]} != 1) {
		  			system (`$msg_cmd $msg_file`);
				}
			$nicks{$list[0]}=1;
			}
  		}
	  	return 0;
	}
}

sub zamfir_command_handler
{
  my $param=shift;
  if (uc $param eq 'ON' ) {
  	IRC::print "\0034:: ZAMFIR is ON ::\003 \n";
	$zamfir_sound=1;
	return 1;
  } else {
	  if (uc $param eq 'OFF' ) {
  		IRC::print "\0034:: ZAMFIR is OFF ::\003 \n";
		$zamfir_sound=0;
		return 1;
	  }
  }

  if (uc $param eq 'RELOAD') {
	IRC::print "\0034:: ZAMFIR config file reloaded ::\003 \n";
	&zamfir_config_file;
	return 1;
  }

  IRC::print "USAGE: ZAMFIR [ON/OFF] Turns message notification on or off\n";
  IRC::print "       ZAMFIR [RELOAD] Reloads Config file\n";
  return 1;
}

sub zamfir_config_file() {

IRC::print "Loading Zamfir Configure File\n";
open (CONFIG,"$ENV{'HOME'}/.zamfirrc") or die ("Can't find config file in home
directory");

# These come out of the program 'aub'. 

$/="\n"; #I think this gets whacked the first time around, so we'll set it.
  foreach (<CONFIG>) {
    chop;                                       # Trim <CR>
    s/^#.*$//;                                  # Remove comments
    s/[^\\]#.*$//;
    s/\\#/#/g;          # Unescape escaped comments
    next if m/^\s*$/;                           # Skip blank lines
    s/\s+/ /;                                   # Fold white space into 1 <SP>
    s/^ //;                                     # Drop leading and trailing
    s/ $//;                                     #  white space

    ($cmd, $rest) = split(/\s+/, $_, 2);
    &zamfir_parse($cmd, $rest);

  }
  close CONFIG;
  return 1;
}

sub zamfir_parse {
	local ($cmd, $args) = @_;

	if ($cmd =~ m/^command/i) {
		$msg_cmd=$args;
		return;
	}

	if ($cmd =~ m/^file/i) {
		$msg_file=$args;
		return;
	}
	
	if ($cmd =~ m/^beeponce/i) {
		$beeponce=1;
		return;
	}

	if ($cmd =~ m/^beepon/i) {
		$zamfir_sound=1;
		return;
	}
	IRC::print "$cmd unrecognized in .zamfirrc\n";
	return 1;
}


